Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 7525)
@@ -282,13 +282,14 @@
                zst(ji,jj) = pst(ji,jj) + rt0      ! convert SST from Celcius to Kelvin (and set minimum value far above 0 K)
 
+      ! ... components ( U10m - U_oce ) at T-point (unmasked)
+              zwnd_i(ji,jj) = 0.e0  
+              zwnd_j(ji,jj) = 0.e0
+            END DO
+         END DO
+
       ! ----------------------------------------------------------------------------- !
       !      0   Wind components and module at T-point relative to the moving ocean   !
       ! ----------------------------------------------------------------------------- !
 
-      ! ... components ( U10m - U_oce ) at T-point (unmasked)
-              zwnd_i(ji,jj) = 0.e0  
-              zwnd_j(ji,jj) = 0.e0
-            END DO
-         END DO
 #if defined key_cyclone
       CALL wnd_cyc( kt, zwnd_i, zwnd_j )    ! add analytical tropical cyclone (Vincent et al. JGR 2012)
@@ -325,23 +326,29 @@
       ! ocean albedo assumed to be constant + modify now Qsr to include the diurnal cycle                    ! Short Wave
       zztmp = 1. - albo
-      IF( ln_dm2dc ) THEN
-         qsr(:,:) = zztmp * sbc_dcy( sf(jp_qsr)%fnow(:,:,1) ) * tmask(:,:,1)
-      ELSE
-         qsr(:,:) = zztmp *          sf(jp_qsr)%fnow(:,:,1)   * tmask(:,:,1)
+      IF( ln_dm2dc ) THEN    ;    qsr(:,:) = zztmp * sbc_dcy( sf(jp_qsr)%fnow(:,:,1) ) * tmask(:,:,1)
+      ELSE                   ;    qsr(:,:) = zztmp *          sf(jp_qsr)%fnow(:,:,1)   * tmask(:,:,1)
       ENDIF
 
-!$OMP PARALLEL DO schedule(static) private(jj, ji)
+!$OMP PARALLEL
+!$OMP DO schedule(static) private(jj, ji)
       DO jj = 1, jpj
          DO ji = 1, jpi
             zqlw(ji,jj) = (  sf(jp_qlw)%fnow(ji,jj,1) - Stef * zst(ji,jj)*zst(ji,jj)*zst(ji,jj)*zst(ji,jj)  ) * tmask(ji,jj,1)   ! Long  Wave
+         END DO
+      END DO
+!OMP END DO NOWAIT
             ! ----------------------------------------------------------------------------- !
             !     II    Turbulent FLUXES                                                    !
             ! ----------------------------------------------------------------------------- !
 
+!$OMP DO schedule(static) private(jj, ji)
+      DO jj = 1, jpj
+         DO ji = 1, jpi
             ! ... specific humidity at SST and IST
             zqsatw(ji,jj) = zcoef_qsatw * EXP( -5107.4 / zst(ji,jj) )
-
-         END DO
-      END DO
+         END DO
+      END DO
+!$OMP END PARALLEL
+
       ! ... NCAR Bulk formulae, computation of Cd, Ch, Ce at T-point :
       CALL turb_core_2z( rn_zqt, rn_zu, zst, sf(jp_tair)%fnow, zqsatw, sf(jp_humi)%fnow, wndm,   &
@@ -388,17 +395,27 @@
       !  Turbulent fluxes over ocean
       ! -----------------------------
+      IF( ABS( rn_zu - rn_zqt) < 0.01_wp ) THEN
+!$OMP PARALLEL DO schedule(static) private(jj, ji)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               !! q_air and t_air are (or "are almost") given at 10m (wind reference height)
+               zevap(ji,jj) = rn_efac*MAX( 0._wp,     rhoa*Ce(ji,jj)*( zqsatw(ji,jj) - sf(jp_humi)%fnow(ji,jj,1) )*wndm(ji,jj) ) ! Evaporation
+               zqsb (ji,jj) =                     cpa*rhoa*Ch(ji,jj)*( zst   (ji,jj) - sf(jp_tair)%fnow(ji,jj,1) )*wndm(ji,jj)   ! Sensible Heat
+            END DO
+         END DO
+      ELSE
+!$OMP PARALLEL DO schedule(static) private(jj, ji)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               !! q_air and t_air are not given at 10m (wind reference height)
+               ! Values of temp. and hum. adjusted to height of wind during bulk algorithm iteration must be used!!!
+               zevap(ji,jj) = rn_efac*MAX( 0._wp,     rhoa*Ce(ji,jj)*( zqsatw(ji,jj) - zq_zu(ji,jj) )*wndm(ji,jj) )   ! Evaporation
+               zqsb (ji,jj) =                     cpa*rhoa*Ch(ji,jj)*( zst   (ji,jj) - zt_zu(ji,jj) )*wndm(ji,jj)     ! Sensible Heat
+            END DO
+         END DO
+      ENDIF
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF( ABS( rn_zu - rn_zqt) < 0.01_wp ) THEN
-            !! q_air and t_air are (or "are almost") given at 10m (wind reference height)
-               zevap(ji,jj) = rn_efac*MAX( 0._wp,     rhoa*Ce(ji,jj)*( zqsatw(ji,jj) - sf(jp_humi)%fnow(ji,jj,1) )*wndm(ji,jj) ) ! Evaporation
-               zqsb (ji,jj) =                     cpa*rhoa*Ch(ji,jj)*( zst   (ji,jj) - sf(jp_tair)%fnow(ji,jj,1) )*wndm(ji,jj)   ! Sensible Heat
-            ELSE
-            !! q_air and t_air are not given at 10m (wind reference height)
-            ! Values of temp. and hum. adjusted to height of wind during bulk algorithm iteration must be used!!!
-               zevap(ji,jj) = rn_efac*MAX( 0._wp,     rhoa*Ce(ji,jj)*( zqsatw(ji,jj) - zq_zu(ji,jj) )*wndm(ji,jj) )   ! Evaporation
-               zqsb (ji,jj) =                     cpa*rhoa*Ch(ji,jj)*( zst   (ji,jj) - zt_zu(ji,jj) )*wndm(ji,jj)     ! Sensible Heat
-            ENDIF
             zqla (ji,jj) = Lv * zevap(ji,jj)                                                              ! Latent Heat
          END DO
@@ -422,14 +439,14 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-      emp (ji,jj) = (  zevap(ji,jj)                                          &   ! mass flux (evap. - precip.)
-         &         - sf(jp_prec)%fnow(ji,jj,1) * rn_pfac  ) * tmask(ji,jj,1)
-      !
-      qns(ji,jj) = zqlw(ji,jj) - zqsb(ji,jj) - zqla(ji,jj)                                &   ! Downward Non Solar 
-         &     - sf(jp_snow)%fnow(ji,jj,1) * rn_pfac * lfus                         &   ! remove latent melting heat for solid precip
-         &     - zevap(ji,jj) * pst(ji,jj) * rcp                                      &   ! remove evap heat content at SST
-         &     + ( sf(jp_prec)%fnow(ji,jj,1) - sf(jp_snow)%fnow(ji,jj,1) ) * rn_pfac  &   ! add liquid precip heat content at Tair
-         &     * ( sf(jp_tair)%fnow(ji,jj,1) - rt0 ) * rcp                          &
-         &     + sf(jp_snow)%fnow(ji,jj,1) * rn_pfac                                &   ! add solid  precip heat content at min(Tair,Tsnow)
-         &     * ( MIN( sf(jp_tair)%fnow(ji,jj,1), rt0_snow ) - rt0 ) * cpic * tmask(ji,jj,1)
+            emp (ji,jj) = (  zevap(ji,jj)                                          &   ! mass flux (evap. - precip.)
+               &         - sf(jp_prec)%fnow(ji,jj,1) * rn_pfac  ) * tmask(ji,jj,1)
+            !
+            qns(ji,jj) = zqlw(ji,jj) - zqsb(ji,jj) - zqla(ji,jj)                                &   ! Downward Non Solar 
+               &     - sf(jp_snow)%fnow(ji,jj,1) * rn_pfac * lfus                         &   ! remove latent melting heat for solid precip
+               &     - zevap(ji,jj) * pst(ji,jj) * rcp                                      &   ! remove evap heat content at SST
+               &     + ( sf(jp_prec)%fnow(ji,jj,1) - sf(jp_snow)%fnow(ji,jj,1) ) * rn_pfac  &   ! add liquid precip heat content at Tair
+               &     * ( sf(jp_tair)%fnow(ji,jj,1) - rt0 ) * rcp                          &
+               &     + sf(jp_snow)%fnow(ji,jj,1) * rn_pfac                                &   ! add solid  precip heat content at min(Tair,Tsnow)
+               &     * ( MIN( sf(jp_tair)%fnow(ji,jj,1), rt0_snow ) - rt0 ) * cpic * tmask(ji,jj,1)
          END DO
       END DO
@@ -454,10 +471,10 @@
          CALL iom_put( "qt_oce"  ,   qns+qsr )              ! output total downward heat over the ocean
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            tprecip(ji,jj) = sf(jp_prec)%fnow(ji,jj,1) * rn_pfac   ! output total precipitation [kg/m2/s]
-            sprecip(ji,jj) = sf(jp_snow)%fnow(ji,jj,1) * rn_pfac   ! output solid precipitation [kg/m2/s]
-         END DO
-      END DO
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               tprecip(ji,jj) = sf(jp_prec)%fnow(ji,jj,1) * rn_pfac   ! output total precipitation [kg/m2/s]
+               sprecip(ji,jj) = sf(jp_snow)%fnow(ji,jj,1) * rn_pfac   ! output solid precipitation [kg/m2/s]
+           END DO
+         END DO
          CALL iom_put( 'snowpre', sprecip * 86400. )        ! Snow
          CALL iom_put( 'precip' , tprecip * 86400. )        ! Total precipitation
@@ -598,5 +615,5 @@
       REAL(wp) ::   zst2, zst3
       REAL(wp) ::   zcoef_dqlw, zcoef_dqla, zcoef_dqsb
-      REAL(wp) ::   zztmp, z1_lsub                               ! temporary variable
+      REAL(wp) ::   zztmp, z1_lsub, ztmp1, ztmp2                 ! temporary variable
       !!
       REAL(wp), DIMENSION(:,:,:), POINTER ::   z_qlw             ! long wave heat flux over ice
@@ -706,5 +723,4 @@
 !$OMP END PARALLEL
       CALL lim_thd_snwblow( pfrld, zsnw )  ! snow distribution over ice after wind blowing 
-   
       emp_oce(:,:) = pfrld(:,:) * zevap(:,:) - ( tprecip(:,:) - sprecip(:,:) ) - sprecip(:,:) * (1._wp - zsnw )
       emp_ice(:,:) = SUM( a_i_b(:,:,:) * evap_ice(:,:,:), dim=3 ) - sprecip(:,:) * zsnw
@@ -712,10 +728,10 @@
 
       ! --- heat flux associated with emp --- !
-      qemp_oce(:,:) = - pfrld(:,:) * zevap(:,:) * sst_m(:,:) * rcp                            & ! evap at sst
-      &          + ( tprecip(:,:) - sprecip(:,:) ) * ( sf(jp_tair)%fnow(:,:,1) - rt0 ) * rcp  & ! liquid precip at Tair
-      &          +   sprecip(:,:) * ( 1._wp - zsnw ) *                                    & ! solid precip at min(Tair,Tsnow)
-      &              ( ( MIN( sf(jp_tair)%fnow(:,:,1), rt0_snow ) - rt0 ) * cpic * tmask(:,:,1) - lfus )
-      qemp_ice(:,:) =   sprecip(:,:) * zsnw *                                                   & ! solid precip (only)
-      &              ( ( MIN( sf(jp_tair)%fnow(:,:,1), rt0_snow ) - rt0 ) * cpic * tmask(:,:,1) - lfus )
+      qemp_oce(:,:) = - pfrld(:,:) * zevap(:,:) * sst_m(:,:) * rcp                               & ! evap at sst
+         &          + ( tprecip(:,:) - sprecip(:,:) ) * ( sf(jp_tair)%fnow(:,:,1) - rt0 ) * rcp  & ! liquid precip at Tair
+         &          +   sprecip(:,:) * ( 1._wp - zsnw ) *                                        & ! solid precip at min(Tair,Tsnow)
+         &              ( ( MIN( sf(jp_tair)%fnow(:,:,1), rt0_snow ) - rt0 ) * cpic * tmask(:,:,1) - lfus )
+      qemp_ice(:,:) =   sprecip(:,:) * zsnw *                                                    & ! solid precip (only)
+         &              ( ( MIN( sf(jp_tair)%fnow(:,:,1), rt0_snow ) - rt0 ) * cpic * tmask(:,:,1) - lfus )
 
       ! --- total solar and non solar fluxes --- !
@@ -723,6 +739,5 @@
       qsr_tot(:,:) = pfrld(:,:) * qsr_oce(:,:) + SUM( a_i_b(:,:,:) * qsr_ice(:,:,:), dim=3 )
 
-      ! --- heat content of precip over ice in J/m3 (to be used in 1D-thermo)
-      ! --- !
+      ! --- heat content of precip over ice in J/m3 (to be used in 1D-thermo) --- !
       qprec_ice(:,:) = rhosn * ( ( MIN( sf(jp_tair)%fnow(:,:,1), rt0_snow ) - rt0 ) * cpic * tmask(:,:,1) - lfus )
 
@@ -741,9 +756,11 @@
       ! ( Maykut and Untersteiner, 1971 ; Ebert and Curry, 1993 )
       !
+      ztmp1 = ( 0.18 * ( 1.0 - cldf_ice ) + 0.35 * cldf_ice )
+      ztmp2 = ( 0.82 * ( 1.0 - cldf_ice ) + 0.65 * cldf_ice )
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
       DO jj = 1, jpj
          DO ji = 1, jpi
-            fr1_i0(ji,jj) = ( 0.18 * ( 1.0 - cldf_ice ) + 0.35 * cldf_ice )
-            fr2_i0(ji,jj) = ( 0.82 * ( 1.0 - cldf_ice ) + 0.65 * cldf_ice )
+            fr1_i0(ji,jj) = ztmp1
+            fr2_i0(ji,jj) = ztmp2
          END DO
       END DO
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 7525)
@@ -195,6 +195,6 @@
             END DO
 !$OMP END DO NOWAIT
-!$OMP DO schedule(static) private(jp,jj,ji)
             DO jp = 1, jpts
+!$OMP DO schedule(static) private(jj,ji)
                DO jj = 1, jpj
                   DO ji = 1, jpi
@@ -336,13 +336,13 @@
          !                                         ! ---------------------------------------- !
 !$OMP PARALLEL DO schedule(static) private(jj,ji)
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  utau_b(ji,jj) = utau(ji,jj)                         ! Swap the ocean forcing fields
-                  vtau_b(ji,jj) = vtau(ji,jj)                         ! (except at nit000 where before fields
-                  qns_b (ji,jj) = qns (ji,jj)                         !  are set at the end of the routine)
-                  emp_b (ji,jj) = emp (ji,jj)
-                  sfx_b (ji,jj) = sfx (ji,jj)
-               END DO
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               utau_b(ji,jj) = utau(ji,jj)                         ! Swap the ocean forcing fields
+               vtau_b(ji,jj) = vtau(ji,jj)                         ! (except at nit000 where before fields
+               qns_b (ji,jj) = qns (ji,jj)                         !  are set at the end of the routine)
+               emp_b (ji,jj) = emp (ji,jj)
+               sfx_b (ji,jj) = sfx (ji,jj)
             END DO
+         END DO
          IF ( ln_rnf ) THEN
 !$OMP PARALLEL
@@ -354,6 +354,6 @@
             END DO
 !$OMP END DO NOWAIT
-!$OMP DO schedule(static) private(jp,jj,ji)
             DO jp = 1, jpts
+!$OMP DO schedule(static) private(jj,ji)
                DO jj = 1, jpj
                   DO ji = 1, jpi
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/TRA/traadv.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/TRA/traadv.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/TRA/traadv.F90	(revision 7525)
@@ -100,14 +100,18 @@
       !
       !                                         !==  effective transport  ==!
-!$OMP PARALLEL DO schedule(static) private(jk)
+!$OMP PARALLEL DO schedule(static) private(jk jj, ji)
       DO jk = 1, jpkm1
-         zun(:,:,jk) = e2u  (:,:) * e3u_n(:,:,jk) * un(:,:,jk)                  ! eulerian transport only
-         zvn(:,:,jk) = e1v  (:,:) * e3v_n(:,:,jk) * vn(:,:,jk)
-         zwn(:,:,jk) = e1e2t(:,:)                 * wn(:,:,jk)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zun(ji,jj,jk) = e2u  (ji,jj) * e3u_n(ji,jj,jk) * un(ji,jj,jk)                  ! eulerian transport only
+               zvn(ji,jj,jk) = e1v  (ji,jj) * e3v_n(ji,jj,jk) * vn(ji,jj,jk)
+               zwn(ji,jj,jk) = e1e2t(ji,jj)                   * wn(ji,jj,jk)
+            END DO
+         END DO
       END DO
       !
       IF( ln_vvl_ztilde .OR. ln_vvl_layer ) THEN                                ! add z-tilde and/or vvl corrections
 !$OMP PARALLEL DO schedule(static) private(jk, jj, ji)
-         DO jk = 1, jpk
+         DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_fct.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_fct.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_fct.F90	(revision 7525)
@@ -339,9 +339,9 @@
          IF( ln_linssh ) THEN    ! top ocean value: high order = upstream  ==>>  zwz=0
 !$OMP PARALLEL DO schedule(static) private(jj, ji)
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     zwz(ji,jj,1) = 0._wp   ! only ocean surface as interior zwz values have been w-masked
-                  END DO
-               END DO
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  zwz(ji,jj,1) = 0._wp   ! only ocean surface as interior zwz values have been w-masked
+               END DO
+            END DO
          ENDIF
          !
@@ -368,5 +368,5 @@
          !
          IF( l_trd ) THEN     ! trend diagnostics (contribution of upstream fluxes)
-!$OMP DO schedule(static) private(jk, jj, ji)
+!$OMP PARALLEL DO schedule(static) private(jk, jj, ji)
             DO jk = 1, jpk
                DO jj = 1, jpj
@@ -375,7 +375,7 @@
                      ztrdy(ji,jj,jk) = ztrdy(ji,jj,jk) + zwy(ji,jj,jk)  ! <<< Add to previously computed
                      ztrdz(ji,jj,jk) = ztrdz(ji,jj,jk) + zwz(ji,jj,jk)  ! <<< Add to previously computed
-               END DO
-            END DO
-         END DO
+                  END DO
+               END DO
+            END DO
             !
             CALL trd_tra( kt, cdtype, jn, jptra_xad, ztrdx, pun, ptn(:,:,:,jn) )
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_mus.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_mus.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_mus.F90	(revision 7525)
@@ -114,15 +114,19 @@
 !$OMP PARALLEL
 !$OMP DO schedule(static) private(jj, ji)
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               upsmsk(ji,jj) = 0._wp                             ! not upstream by default
-            END DO
-         END DO
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  upsmsk(ji,jj) = 0._wp                             ! not upstream by default
+               END DO
+            END DO
             !
-!$OMP DO schedule(static) private(jk)
+!$OMP DO schedule(static) private(jk,jj,ji)
             DO jk = 1, jpkm1
-               xind(:,:,jk) = 1._wp                              &                 ! =>1 where up-stream is not needed
-                  &         - MAX ( rnfmsk(:,:) * rnfmsk_z(jk),  &                 ! =>0 near runoff mouths (& closed sea outflows)
-                  &                 upsmsk(:,:)                ) * tmask(:,:,jk)   ! =>0 in some user defined area
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     xind(ji,jj,jk) = 1._wp                              &                   ! =>1 where up-stream is not needed
+                        &         - MAX ( rnfmsk(ji,jj) * rnfmsk_z(jk),  &                   ! =>0 near runoff mouths (& closed sea outflows)
+                        &                 upsmsk(ji,jj)                ) * tmask(ji,jj,jk)   ! =>0 in some user defined area
+                  END DO
+               END DO
             END DO
 !$OMP END DO NOWAIT
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 7525)
@@ -128,7 +128,12 @@
       IF( l_trdtra ) THEN      ! trends diagnostic: save the input temperature trend
          CALL wrk_alloc( jpi,jpj,jpk,   ztrdt ) 
-!$OMP PARALLEL WORKSHARE
-         ztrdt(:,:,:) = tsa(:,:,:,jp_tem)
-!$OMP END PARALLEL WORKSHARE
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
+            DO jk = 1, jpk
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     ztrdt(ji,jj,jk) = tsa(ji,jj,jk,jp_tem)
+                  END DO
+               END DO
+            END DO
       ENDIF
       !
@@ -144,13 +149,23 @@
          ELSE                                           ! No restart or restart not found: Euler forward time stepping
             z1_2 = 1._wp
-!$OMP PARALLEL WORKSHARE
-            qsr_hc_b(:,:,:) = 0._wp
-!$OMP END PARALLEL WORKSHARE
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
+            DO jk = 1, jpk
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     qsr_hc_b(ji,jj,jk) = 0._wp
+                  END DO
+               END DO
+            END DO
          ENDIF
       ELSE                             !==  Swap of qsr heat content  ==!
          z1_2 = 0.5_wp
-!$OMP PARALLEL WORKSHARE
-         qsr_hc_b(:,:,:) = qsr_hc(:,:,:)
-!$OMP END PARALLEL WORKSHARE
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
+            DO jk = 1, jpk
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     qsr_hc_b(ji,jj,jk) = qsr_hc(ji,jj,jk)
+                  END DO
+               END DO
+            END DO
       ENDIF
       !
@@ -161,7 +176,11 @@
       CASE( np_BIO )                   !==  bio-model fluxes  ==!
          !
-!$OMP PARALLEL DO schedule(static) private(jk)
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
          DO jk = 1, nksr
-            qsr_hc(:,:,jk) = r1_rau0_rcp * ( etot3(:,:,jk) - etot3(:,:,jk+1) )
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  qsr_hc(ji,jj,jk) = r1_rau0_rcp * ( etot3(ji,jj,jk) - etot3(ji,jj,jk+1) )
+               END DO
+             END DO
          END DO
          !
@@ -198,7 +217,11 @@
             END DO
          ELSE                                !* constant chrlorophyll
-!$OMP PARALLEL DO schedule(static) private(jk)
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
            DO jk = 1, nksr + 1
-              zchl3d(:,:,jk) = 0.05 
+              DO jj = 1, jpj
+                 DO ji = 1, jpi
+                    zchl3d(ji,jj,jk) = 0.05 
+                 ENDDO
+              ENDDO
             ENDDO
          ENDIF
@@ -305,7 +328,10 @@
          !
 !$OMP PARALLEL
-!$OMP WORKSHARE
-         zetot(:,:,nksr+1:jpk) = 0._wp     ! below ~400m set to zero
-!$OMP END WORKSHARE
+!$OMP DO schedule(static) private(jj,ji)
+         DO jj = 1, jpj 
+            DO ji = 1, jpi   ! vector opt.
+               zetot(ji,jj,nksr+1:jpk) = 0._wp     ! below ~400m set to zero
+            END DO
+         END DO
          DO jk = nksr, 1, -1
 !$OMP DO schedule(static) private(jj,ji)
@@ -329,7 +355,12 @@
       !
       IF( l_trdtra ) THEN     ! qsr tracers trends saved for diagnostics
-!$OMP PARALLEL WORKSHARE
-         ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
-!$OMP END PARALLEL WORKSHARE
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
+         DO jk = 1, jpk
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ztrdt(ji,jj,jk) = tsa(ji,jj,jk,jp_tem) - ztrdt(ji,jj,jk)
+               END DO
+            END DO
+         END DO
          CALL trd_tra( kt, 'TRA', jp_tem, jptra_qsr, ztrdt )
          CALL wrk_dealloc( jpi,jpj,jpk,   ztrdt ) 
@@ -458,7 +489,12 @@
       END SELECT
       !
-!$OMP PARALLEL WORKSHARE
-      qsr_hc(:,:,:) = 0._wp     ! now qsr heat content set to zero where it will not be computed
-!$OMP END PARALLEL WORKSHARE
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji)
+      DO jk = 1, jpk
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               qsr_hc(ji,jj,jk) = 0._wp     ! now qsr heat content set to zero where it will not be computed
+            END DO
+         END DO
+      END DO
       !
       ! 1st ocean level attenuation coefficient (used in sbcssm)
@@ -466,7 +502,10 @@
          CALL iom_get( numror, jpdom_autoglo, 'fraqsr_1lev'  , fraqsr_1lev  )
       ELSE
-!$OMP PARALLEL WORKSHARE
-         fraqsr_1lev(:,:) = 1._wp   ! default : no penetration
-!$OMP END PARALLEL WORKSHARE
+!$OMP PARALLEL DO schedule(static) private(jj,ji)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               fraqsr_1lev(ji,jj) = 1._wp   ! default : no penetration
+            END DO
+         END DO
       ENDIF
       !
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 7525)
@@ -900,10 +900,14 @@
       !                               !* set vertical eddy coef. to the background value
 !$OMP PARALLEL
-!$OMP DO schedule(static) private(jk)
+!$OMP DO schedule(static) private(jk,jj,ji)
       DO jk = 1, jpk
-         avt (:,:,jk) = avtb(jk) * wmask (:,:,jk)
-         avm (:,:,jk) = avmb(jk) * wmask (:,:,jk)
-         avmu(:,:,jk) = avmb(jk) * wumask(:,:,jk)
-         avmv(:,:,jk) = avmb(jk) * wvmask(:,:,jk)
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               avt (ji,jj,jk) = avtb(jk) * wmask (ji,jj,jk)
+               avm (ji,jj,jk) = avmb(jk) * wmask (ji,jj,jk)
+               avmu(ji,jj,jk) = avmb(jk) * wumask(ji,jj,jk)
+               avmv(ji,jj,jk) = avmb(jk) * wvmask(ji,jj,jk)
+            END DO
+         END DO
       END DO
 !$OMP END DO NOWAIT
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftmx.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftmx.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftmx.F90	(revision 7525)
@@ -529,11 +529,11 @@
 !$OMP PARALLEL
 !$OMP DO schedule(static) private(jk, jj, ji) 
-      DO jk = 1, jpk
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zav_tide(ji,jj,jk) = 0.e0
-            END DO
-         END DO
-      END DO
+         DO jk = 1, jpk
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  zav_tide(ji,jj,jk) = 0.e0
+               END DO
+            END DO
+         END DO
 !$OMP DO schedule(static) private(jk)
          DO jk = 2, jpkm1
@@ -1024,5 +1024,6 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            znu_t(ji,jj,jk) = 1.e-4_wp * (  17.91_wp - 0.53810_wp * tsn(ji,jj,jk,jp_tem) + 0.00694_wp * tsn(ji,jj,jk,jp_tem) * tsn(ji,jj,jk,jp_tem)  &
+            znu_t(ji,jj,jk) = 1.e-4_wp * (  17.91_wp - 0.53810_wp * tsn(ji,jj,jk,jp_tem) &
+         &                                  + 0.00694_wp * tsn(ji,jj,jk,jp_tem) * tsn(ji,jj,jk,jp_tem)  &
          &                                  + 0.02305_wp * tsn(ji,jj,jk,jp_sal)  ) * tmask(ji,jj,jk) * r1_rau0
          END DO
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 7525)
@@ -73,5 +73,5 @@
       !!              -8- Outputs and diagnostics
       !!----------------------------------------------------------------------
-      INTEGER ::   jk, jj, ji, jt       ! dummy loop indice
+      INTEGER ::   jn, jk, jj, ji       ! dummy loop indice
       INTEGER ::   indic    ! error indicator if < 0
       INTEGER ::   kcall    ! optional integer argument (dom_vvl_sf_nxt)
@@ -202,26 +202,13 @@
                &                                          rhd, gru , grv , grui, grvi   )  ! of t, s, rd at the first ocean level
 !!jc: fs simplification
-!$OMP PARALLEL
-!$OMP DO schedule(static) private(jk, jj, ji)
-         DO jk = 1, jpk
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  ua(ji,jj,jk) = 0._wp            ! set dynamics trends to zero
-                  va(ji,jj,jk) = 0._wp
-               END DO
+!$OMP PARALLEL DO schedule(static) private(jk, jj, ji)
+      DO jk = 1, jpk
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               ua(ji,jj,jk) = 0._wp            ! set dynamics trends to zero
+               va(ji,jj,jk) = 0._wp
             END DO
          END DO
-!$OMP END DO NOWAIT
-!$OMP DO schedule(static) private(jt, jk, jj, ji)
-         DO jt = 1, jpts
-            DO jk = 1, jpk
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     tsa(ji,jj,jk,jt) = 0._wp         ! set tracer trends to zero
-                  END DO
-               END DO
-            END DO
-         END DO
-!$OMP END PARALLEL
+      END DO
       IF(  lk_asminc .AND. ln_asmiau .AND. ln_dyninc )   &
                &         CALL dyn_asm_inc   ( kstp )  ! apply dynamics assimilation increment
@@ -276,4 +263,14 @@
       ! Active tracers                              
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+      DO jn = 1, jpts
+!$OMP PARALLEL DO schedule(static) private(jk, jj, ji)
+         DO jk = 1, jpk
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  tsa(ji,jj,jk,jn) = 0._wp         ! set tracer trends to zero
+               END DO
+            END DO
+         END DO
+      END DO
       IF(  lk_asminc .AND. ln_asmiau .AND. &
          & ln_trainc )   CALL tra_asm_inc   ( kstp )  ! apply tracer assimilation increment
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zche.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zche.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zche.F90	(revision 7525)
@@ -199,5 +199,6 @@
       ! CHEMICAL CONSTANTS - DEEP OCEAN
       ! -------------------------------
-!$OMP DO schedule(static) private(jk,jj,ji,zpres,ztkel,zsal,zsqrt,zsal15,zlogt,ztr,zis,zis2,zisqrt,ztc,zcl,zst,zft,zcks,zckf,zckb,zck1,zck2,zckw,zaksp0,zak1,zak2,zakb,zakw,zaksp1,zcpexp,zcpexp2,zbuf1,zbuf2)
+!$OMP DO schedule(static) private(jk,jj,ji,zpres,ztkel,zsal,zsqrt,zsal15,zlogt,ztr,zis,zis2,zisqrt,ztc,zcl,zst) &
+!$OMP& private(zft,zcks,zckf,zckb,zck1,zck2,zckw,zaksp0,zak1,zak2,zakb,zakw,zaksp1,zcpexp,zcpexp2,zbuf1,zbuf2)
       DO jk = 1, jpk
          DO jj = 1, jpj
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90	(revision 7525)
@@ -136,5 +136,6 @@
             END DO
          END DO
-!$OMP DO schedule(static) private(jk,jj,ji,ztligand,zionic,zph,zoxy,zkox,zkph2,zkph1,ztfe,za,zb,zc,zkappa1,zkappa2,za2,za1,za0,zp,zq,zp3,zq2,zd,zr,zphi,zxs,zfff,zfunc)
+!$OMP DO schedule(static) private(jk,jj,ji,ztligand,zionic,zph,zoxy,zkox,zkph2,zkph1,ztfe,za) &
+!$OMP& private(zb,zc,zkappa1,zkappa2,za2,za1,za0,zp,zq,zp3,zq2,zd,zr,zphi,zxs,zfff,zfunc)
          DO jk = 1, jpkm1
             DO jj = 1, jpj
@@ -240,5 +241,6 @@
       zdust = 0.         ! if no dust available
       !
-!$OMP PARALLEL DO schedule(static) private(jk,jj,ji,zkeq,zfesatur,ztfe,zstep,zfeequi,zfecoll,ztrc,zlam1b,zscave,zdenom1,zdenom2,zlamfac,zdep,zcoag,zlam1a,zaggdfea,zaggdfeb)
+!$OMP PARALLEL DO schedule(static) private(jk,jj,ji,zkeq,zfesatur,ztfe,zstep,zfeequi,zfecoll) &
+!$OMP& private(ztrc,zlam1b,zscave,zdenom1,zdenom2,zlamfac,zdep,zcoag,zlam1a,zaggdfea,zaggdfeb)
       DO jk = 1, jpkm1
          DO jj = 1, jpj
Index: branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlim.F90
===================================================================
--- branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlim.F90	(revision 7517)
+++ branches/2016/dev_r6519_HPC_4/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlim.F90	(revision 7525)
@@ -84,5 +84,6 @@
       !
 !$OMP PARALLEL
-!$OMP DO schedule(static) private(jk,jj,ji,zno3,zferlim,zconcd,zconcd2,zconcn,zconcn2,z1_trbphy,z1_trbdia,zconc1d,zconc1dnh4,zconc0n,zconc0nnh4,zdenom,zlim1,zlim2,zlim3,zlim4,zratio,zironmin)
+!$OMP DO schedule(static) private(jk,jj,ji,zno3,zferlim,zconcd,zconcd2,zconcn,zconcn2,z1_trbphy,z1_trbdia) &
+!$OMP& private(zconc1d,zconc1dnh4,zconc0n,zconc0nnh4,zdenom,zlim1,zlim2,zlim3,zlim4,zratio,zironmin)
       DO jk = 1, jpkm1
          DO jj = 1, jpj
